

/**
 * 
 * from original code by Tom Igoe(SerialDuplex) and Andreas Schegel(controlp5) . 
 * 
 * Sends a byte out the serial port when you type a key
 * listens for bytes received, and displays their vaflue. 
 * This is just a quick application for testing serial data
 * in both directions. 
 */
import org.openkinect.freenect.*;
import org.openkinect.freenect2.*;
import org.openkinect.processing.*;
import javax.swing.JOptionPane;
//import KinectPV2.*;
import controlP5.*;
import processing.serial.*;

import processing.video.*;
import controlP5.*;
import java.util.*;
import java.awt.*;
import java.util.List;

//KinectPV2 kinect;
PImage screenshot;
Kinect2 kinect;
PrintWriter ply;
PrintWriter raw;

ControlP5 cp5;
ControlP5 cp4;
ControlP5 cp2;
ControlP5 cp0;
Textarea myTextarea;
Println console;

Serial myPort;      // The serial port
int baudrate=115200;
int rectx=0;
int recty=0;
int rectwidth=0;
int rectheight=0;
int whichKey = -1;  // Variable to hold keystoke values
int inByte = -1;    // Incoming serial data
int inByte2 = -1;
int whichport=-1;
int seq = 0;
int connectcolor = color(255);
int serial_togglex = 900;
int serial_toggley = 450;
int serial_toggle_ellipsex=serial_togglex+30;
int serial_toggle_ellipsey=serial_toggley-30;
int goodpoints = 10000;
int pointcolor=0;
int hubaddress=0;
boolean export_region=false;
boolean connected = false;
boolean isByteZero = true;
boolean portOpen = false;
boolean doframe = true;
boolean kinectstart = true;
boolean firsttime=true;
boolean doexit = false;
boolean iscmd = true;
boolean getlut=false;
boolean ismeasurement=false;
boolean showcamera = true;
boolean startup=false;
boolean getP2screen = false;
boolean serialImageReady=false;
int i = 511;
int j = -1;
int samples = 5;
int whichsample = 0;
int whichbyte =-1;
int  w = 1200;
int  h = 600;
int a = 0;
int myColor = color(0);
int c1, c2;
float n, n1;
int LUT_INDEX= 511;
int ScanLine=212;
int lut_long=0;
int temp_byte=0;
int word0 = 0;
int word1=0;
String byte_string="  ";
String inst_string=" ";
String path = "C:/Users/Public/processing-3.0.1/kinectData/";
String pointString = " ";
int[] lutBytes=new int[2048];
int[] inBytes = new int[77000]; 
byte [] imgbytes = new byte[76800];
byte[] kinectbytes =new byte[230400];
byte byte_byte=0;
int[][] rawData;
int[][] rawDataMirror;
int [] temparray;
int[] irData;
int[] irDataMirror;

PImage rawimg;
PImage serialimg;
PImage mirror_regImg;
PImage irimg;
PImage hubimg;
int lookline=212;
int rawimagestartx =0;
int rawimagestarty=0;
int rawimagewidth=512;
int rawimageheight = 424;
int linemeasurementoffset=0;
int loc=0;
int xloc=0;
int yloc=0;
int startx = 0;
int starty = 0;
int endx  = 0;
int endy = 0;
int cxloc=0;
int cyloc=0;
int cpointloc=0;
float inches = 0.0;
float d = 0.0;
float floatx=0.0;
float floaty=0.0;
float floatz = 0.0;
float floatx2=0.0;
float floaty2=0.0;
float floatz2 = 0.0;
float dx = 0.0;
float dy = 0.0;
float dz = 0.0;
float hfov = 70.6;
float hfovc = 84.1;
float vfov = 60.0;
float vfovc= 53.8;
float hradsperpixel = (70.6/512)*(TWO_PI/360);
float vradsperpixel = (60.0/424)*(TWO_PI/360);
float aaa =0.0; //hypotenuse for x case
float bbb=0.0;
float ccc=0.0;// side adjacent for x case
float aaa2=0.0; //hypotenuse for y case                                                             
float bbb2=0.0;
float ccc2=0.0;// side adjacent for y case
float wheelpos=0.0;
List l ;

void setup() {
  size(1370, 1020, P3D);
  strokeWeight(2);

  String[] instructions = loadStrings("instructionsv6.txt");
  int mytempint = instructions.length;
  println("instructions.length"+instructions.length);
  for ( int kj = 20; kj < mytempint; kj++) {
    String mytempstring =instructions[kj];
    println(mytempstring);
  }
  ccc= 256/sin(35.3*TWO_PI/360);
  println("ccc="+ccc);
  aaa=sqrt((ccc*ccc)-(256*256));
  ccc2=212/sin(30.0*TWO_PI/360);
  println("ccc2="+ccc2);

  ccc=365.456;//375;//365.456;
  ccc2=ccc;
  aaa2=sqrt((ccc2*ccc2)-(212*212));

  rawimg =  createImage(512, 424, RGB);

  rawimg.loadPixels();

  serialimg=createImage(320, 240, RGB);
  serialimg.loadPixels();
 // saveSerialImage();
  mirror_regImg =createImage(512, 424, RGB);
  mirror_regImg.loadPixels();
  rawData = new int[512*424] [samples];
  rawDataMirror = new int[512*424] [samples];
  temparray=new int[512*424];

  kinect = new Kinect2(this);
  kinect.initDepth();
  kinect.initRegistered();
  // kinect.init();
  cp4 = new ControlP5(this);
  cp4.addToggle("Toggle_Serial")
    .setPosition(serial_togglex, serial_toggley)
    .setSize(60, 20)
    .setValue(false)
    .setMode(ControlP5.SWITCH)
    ;
  l = Arrays.asList(Serial.list());
  List b = Arrays.asList("9_600", "57_600", "115_200", "230_400", "460_800", "1_225_000","3_000_000");
  //println(l);
  /* add a ScrollableList, by default it behaves like a DropdownList */
  cp4.addScrollableList("Port")
    .setPosition(serial_togglex-220, serial_toggley-40)
    .setSize(75, 100)
    .setBarHeight(20)
    .setItemHeight(20)
    .addItems(l)
    //  .setType(ScrollableList.LIST) // currently supported DROPDOWN and LIST
    ;

  cp4.addScrollableList("Baud")
    .setPosition(serial_togglex-120, serial_toggley-40)
    .setSize(75, 100)
    .setBarHeight(20)
    .setItemHeight(20)
    .addItems(b);
  //  .setType(ScrollableList.LIST) // currently supported DROPDOWN and LIST
  ;

  cp0 = new ControlP5(this);
  myTextarea = cp0.addTextarea("txt")
    .setPosition(915, 10)
    .setSize(430, 300)
    .setFont(createFont("", 12))
    .setLineHeight(14)
    .setColor(color(200))
    .setColorBackground(color(0, 100))
    .setColorForeground(color(255, 100));
  ;

  console = cp0.addConsole(myTextarea);//



  cp5 = new ControlP5(this);
  cp5.addButton("KinectV2")
    .setValue(0)
    .setPosition(600, 520)
    .setSize(100, 40)
    ;

  cp5.addButton("Export_ply")
    .setValue(0)
    .setPosition(600, 562)
    .setSize(100, 40)
    ;

  cp5.addButton("Export_Region_ply")
    .setValue(0)
    .setPosition(600, 602)
    .setSize(100, 40)
    ;
  //  cp5 = new ControlP5(this);
  cp5.addButton("EXIT")
    .setValue(0)
    .setPosition(512, 520)
    .setSize(80, 40)
    ;
  cp5.addSlider("LUT_INDEX")
    .setPosition(w/2, height-40)
    .setSize(512, 20)
    .setRange(0, 511)
    .setValue(0)
    .setNumberOfTickMarks(512)
    ;

  cp5.addSlider("ScanLine")
    .setPosition(525, 0)
    .setSize(20, 424)
    .setRange(423, 0)
    .setValue(212)
    ;
  PFont myFont = createFont(PFont.list()[2], 18);
  textFont(myFont);

  // List all the available serial ports:
  printArray(Serial.list());


 // console.clear();

  for ( int kj = 20; kj < instructions.length-1; kj++) { //<>//
    String mytempstring =instructions[kj];

    if (mytempstring.length()<4) {
      println("__");
    }
    if (mytempstring.length()>3) {
      println(mytempstring);
    }
  }
  export_region=false;
  iscmd=true;
  doframe=true;
  startup=true;
}
//******************************************************************
void draw() {


  background(myColor);
  if (frameCount % 2 == 0) {
    screenshot();
    // screenshot.filter(GRAY);
  }
  if (screenshot != null) {
    image(screenshot, 600, 0, 320, 240);
  }
  
  image(serialimg, 800, 550);
  //  rawimg.loadPixels();

  //  if ((portOpen==true) && (iscmd==true)) {
  //  myPort.write(0);
  // }


  if ((kinectstart==true)&&(doframe==true)) {
    // image(rawimg, rawimagestartx, rawimagestarty);
    mirror_regImg=kinect.getRegisteredImage();
    pushMatrix();
    scale(-1, 1);
    translate(-mirror_regImg.width, 0);

    image(mirror_regImg, rawimagestartx, rawimagestarty);
    popMatrix();
  }
  if (doframe==false) {
    pushMatrix();
    scale(-1, 1);
    translate(-mirror_regImg.width, 0);

    image(mirror_regImg, rawimagestartx, rawimagestarty);
    popMatrix();
    rawgraph();
  }

  if (doframe==false) {
  }
  lookline=int(ScanLine);
  text("FPS   "+frameRate, rawimagestartx+10, rawimagestarty +20);

  if (doframe==true) {
    temparray = kinect.getRawDepth();
    for (i=0; i<512*424; i++) {
      rawData[i][whichsample] = temparray[i];
    }
  }

  if (kinectstart==true) {
    doKinect();
  }

  getNewFrame();

  stroke(0, 255, 0);

  text(mouseX +","+mouseY, 512, h-90);
  if (portOpen==true) {
    String tempstring =Serial.list()[whichport];
    text("Port: " + tempstring, 560, 434);
    text("Last Received: " + inByte + "    j="+j, 560, 474);
    text("Last Sent: " + whichKey, 560, 454);
  } 

  text("LUT Index:  ("+  LUT_INDEX+")  $"+hex(LUT_INDEX, 4), w/2, height-60);
  byte_string=binary(lutBytes[(LUT_INDEX*4)+3], 8)+"  ";
  byte_string= byte_string + binary(lutBytes[(LUT_INDEX*4)+2], 8)+"  ";
  byte_string=byte_string + binary(lutBytes[(LUT_INDEX*4)+1], 8)+"  ";
  byte_string=byte_string + binary(lutBytes[(LUT_INDEX*4)], 8);
  text("BIN: "+byte_string, w/2, height-90);


  inst_string=byte_string.substring(0, 4)+" "+byte_string.substring(4, 11)+ " "+ byte_string.substring(11, 14)+" "+byte_string.substring(14, 23)+" "+ byte_string.substring(23, 32);
  text("INST: "+inst_string, w/2, height-110);

  byte_string=hex(lutBytes[(LUT_INDEX*4)+3], 2);
  byte_string= byte_string + hex(lutBytes[(LUT_INDEX*4)+2], 2);
  byte_string=byte_string + "_";
  byte_string=byte_string + hex(lutBytes[(LUT_INDEX*4)+1], 2);

  byte_string=byte_string + hex(lutBytes[(LUT_INDEX*4)], 2);
  text("HEX: "+byte_string, w-200, 860);

  text("Unsigned Bytes 3->0:     "+ (lutBytes[(LUT_INDEX*4)+3])+","+lutBytes[(LUT_INDEX*4)+2]+","+lutBytes[(LUT_INDEX*4)+1]+","+ lutBytes[(LUT_INDEX*4)+0], w/2, 840);
  text("   Signed Bytes 3->0:       "+ byte(lutBytes[(LUT_INDEX*4)+3])+","+byte(lutBytes[(LUT_INDEX*4)+2])+","+byte(lutBytes[(LUT_INDEX*4)+1])+","+ byte(lutBytes[(LUT_INDEX*4)+0]), w/2, 860);

  word1 = ((lutBytes[(LUT_INDEX*4)+3])<<8)+lutBytes[(LUT_INDEX*4)+2];
  word0 = ((lutBytes[(LUT_INDEX*4)+1])<<8)+lutBytes[(LUT_INDEX*4)+0];
  lut_long=( word1<<16) + word0;
  text("Words 1,0:   "+word1+" , "+word0, w-200, 840);
  text("Hub Address(" + (hubaddress+3+(LUT_INDEX*4))+ "-" + (hubaddress+(LUT_INDEX*4)) + ")" + "$"+hex(hubaddress+(LUT_INDEX*4), 5)+"  Value:  "+  hex(lut_long), 150 + w/2+80, height-60);



  if ((doframe==true)&&(kinectstart==true)) {
    whichsample++;
    if (whichsample==samples) {
      whichsample=0;
    }
    if ((startx<rawimagestartx+rawimagewidth)&&(starty<rawimagestarty+rawimageheight)) {
      rectx=startx;
      recty=starty;
      rectwidth=endx-startx;
      rectheight=endy-starty;
      rect(startx, starty, endx-startx, endy-starty);
    }
  }

  doSerialToggle();
}

//****************************************
void doKinect() {
  line(rawimagestartx, lookline, rawimagestartx+rawimagewidth, lookline);
  if ((mouseX>rawimagestartx)&&(mouseY<(rawimagestarty+rawimageheight))&&(mouseX<(rawimagestartx+rawimagewidth))&& (mouseY>rawimagestarty)) {
    xloc = mouseX-rawimagestartx;
    yloc = mouseY-rawimagestarty;
    cxloc=511-xloc;
    cyloc=yloc;
    cpointloc=cxloc + cyloc*512;
    loc = xloc+(rawimagewidth*yloc);
    if ((loc>-1)&&(loc<rawimagewidth*rawimageheight)) {
      xloc=xloc-(rawimagewidth/2);
      yloc=(rawimageheight/2)-yloc;
      floatz =(rawDataMirror[loc][whichsample]);

      floatx = ((floatz*(xloc/ccc)))/10;

      floaty = ((floatz*(yloc/ccc2)))/10;
      floatz=floatz/10;
      floatx= round( floatx * 100.0f ) / 100.0f;
      floaty= round( floaty * 100.0f ) / 100.0f;
      floatz= round( floatz * 100.0f ) / 100.0f;
      text("x cm  "+floatx, mouseX+60, mouseY+15);
      text("y cm  "+floaty, mouseX+60, mouseY+35);
      text("z cm  "+floatz, mouseX+60, mouseY+55);
      pointcolor = mirror_regImg.pixels[cpointloc];
      text("red,green,blue= "+((pointcolor>>16) & 0xFF ) +","+((pointcolor>>8)& 0xFF)+","+(pointcolor & 0xFF), mouseX, mouseY+75);
    }
    if ((startx!=endx)&&(starty!=endy)) {
      xloc=startx-rawimagestartx;
      yloc=starty-rawimagestarty;
      loc=xloc+(rawimagewidth*yloc);

      if ((loc>-1)&&(loc<512*424)) {
        xloc=xloc-256;
        yloc=212-yloc;
        //   text(xloc+","+yloc, mouseX-40,mouseY-5);
        floatz =rawDataMirror[loc][whichsample];


        float a = hradsperpixel*xloc;
        floatx = ((floatz*(xloc/ccc)))/10;

        float b = (yloc)*vradsperpixel;

        floaty = ((floatz*(yloc/ccc2)))/10;
        floatz = floatz/10;
      }
      xloc=endx-rawimagestartx;
      yloc=endy-rawimagestarty;
      loc=xloc+(rawimagewidth*yloc);
      if ((loc>-1)&&(loc<512*424)) {
        xloc=xloc-256;
        yloc=212-yloc;

        floatz2 =(rawDataMirror[loc][whichsample]);

        floatx2 = ((floatz2*(xloc/ccc)))/10;


        floaty2 = ((floatz2*(yloc/ccc2)))/10;
        floatz2=floatz2/10;
      }
      dx=floatx-floatx2;
      dy=floaty-floaty2;
      dz=floatz-floatz2;

      d = sqrt((dx*dx)+(dy*dy)+(dz*dz) );
      d= round( d * 100.0f ) / 100.0f;
      text("d(cm)="+d, endx, endy+20);
      float feet= d/(2.54*12);
      inches=d/2.54;
      //   text("d(ft)="+feet, endx, endy+20);
    }
  }
  if (ismeasurement==true) {
    text("d(cm)="+d, endx, endy+20);
    text("d(inches)="+inches, endx, endy+40);
  }
}
void doSerialToggle() {
  fill(connectcolor);
  ellipse(serial_toggle_ellipsex, serial_toggle_ellipsey, 20, 20);
  if (connected==true) {
    text("Serial Connected", serial_toggle_ellipsex-80, serial_toggle_ellipsey-15);
  }
  if (connected==false) {
    text("Serial", serial_toggle_ellipsex-26, serial_toggle_ellipsey-15);

    text("Not Connected", serial_toggle_ellipsex-62, serial_toggle_ellipsey+24);
  }
}
void Toggle_Serial(boolean theFlag) {
  connected=theFlag;
  if (theFlag==true) {
    connectcolor = color(0, 255, 0);
    String portName = Serial.list()[whichport];
    myPort = new Serial(this, portName, baudrate);
    portOpen=true;
    //Port(whichport);
  } else {
    connectcolor = color(255, 0, 0);
    if (portOpen==true) {
      connectcolor = color(255, 0, 0);
      myPort.stop();
      portOpen=false;
    }
  }
}
void Baud(int m) {
  /* request the selected item based on index m */

  switch(m) {
    case(0):
    baudrate=9800;
    break;
    case(1):
    baudrate=57600;
    break;
    case(2):
    baudrate=115200;
    break;
    case(3):
    baudrate=230400;
    break;
    case(4):
    baudrate=460800;
    break;
    case(5):
    baudrate=1225000;
    break;
    case(6):
    // baudrate=806400;
    baudrate=3000000;
   // baudrate=1225000;
    break;
  }
}
void Port(int nnn) {
  /* request the selected item based on index n */
  // println(nnn, cp4.get(ScrollableList.class, "Port").getItem(nnn));

  /* here an item is stored as a Map  with the following key-value pairs:
   * name, the given name of the item
   * text, the given text of the item by default the same as name
   * value, the given value of the item, can be changed by using .getItem(n).put("value", "abc"); a value here is of type Object therefore can be anything
   * color, the given color of the item, how to change, see below
   * view, a customizable view, is of type CDrawable 
   */

  CColor c = new CColor();
  c.setBackground(color(255, 0, 0));
  cp4.get(ScrollableList.class, "Port").getItem(nnn).put("color", c);
  whichport=nnn;
  // println("whichport  "+whichport+Serial.list()[whichport]);
}

public void getNewFrame() {

  // rawData = kinect.getRawDepthData();
  // irData = kinect.getInfraredImage();


  if ((doframe==true)&&(kinectstart==true)) {
    fliprawData();
    rawimg.updatePixels();

    rawtoimage();
    rawgraph();
  }
}
public void fliprawData() {
  yloc=0;
  for (int iy=0; iy<424; iy++) {

    for (int ix =0; ix< 512; ix++) {
      xloc =511-ix;
      rawDataMirror[xloc+yloc][whichsample]=rawData[ix+yloc][whichsample];
    }
    yloc = yloc+512;
  }
}
void rawgraph() {      //graphs line of interest to screen
  int tempraw2;
  int oldz =500;
  // rawimg.loadPixels();
  int startlook=lookline*512;
  int finishlook=startlook+512;
  for (int i = startlook; i < finishlook-1; i++) {
    tempraw2=rawDataMirror[i][whichsample];
    int e =height-((tempraw2)/10);
    if (e<0) {
      e=0;
    }
    stroke(255, 255, 255);
    point(i-startlook, e);

    if (tempraw2>500) {
      stroke(0, 0, 255);
      point(i-startlook, lookline+tempraw2-oldz);
      oldz=tempraw2;
    }
    if (tempraw2<500) {
      stroke(255, 0, 0);
      point(i-startlook, lookline+2);
      point(i-startlook, lookline+1);
      point(i-startlook, lookline-1);
      point(i-startlook, lookline-2);
      line(i-startlook, 424, i-startlook, height);
    }
  }
}
void sendDepthMap() {
  long mil1=System.currentTimeMillis();
  doframe=false;

  byte[] depthbytes = new byte[76800];
  int im=0;
  int gz=0;

  for (int iy=92; iy<332; iy++) {
    yloc=iy*512;
    for (int ix=96; ix<416; ix++) {
      xloc=512-ix;

      gz=rawDataMirror[ix+yloc][0];
      gz=gz/16;
      if (gz>255) {
        gz=255;
      }
      gz=255-gz;
      if (gz==255) {
        gz=0;
      }
      depthbytes[im]=byte(gz & 0xFF);
      im++;
    }
  }
  myPort.write(depthbytes);


  long mil2 = System.currentTimeMillis()-mil1;
  println(mil2 + "milliseconds");
  doframe = true;
}
void sendKinectimage() {
  myPort.write(107);

  long mil1=System.currentTimeMillis();
  doframe=false;

  // byte[] imgbytes = new byte[76000];
  int im=0;
  int gz=0;

  for (int iy=92; iy<332; iy++) {
    yloc=iy*512;
    for (int ix=96; ix<416; ix++) {
      xloc=512-ix;
      pointcolor=  mirror_regImg.pixels[xloc+yloc]; 
      kinectbytes[im]=byte((pointcolor>>8) & 0xFF);
      im++;
      gz=rawDataMirror[ix+yloc][0];
      kinectbytes[im]=byte((gz>>8) & 0xFF);
      im++;
      kinectbytes[im]=byte(gz & 0xFF);
      im++;
    }
  }
  myPort.write(kinectbytes);


  long mil2 = System.currentTimeMillis()-mil1;
  println(mil2/100);
  println(mil2+" milliseconds");
  doframe = true;
}
////////////////////////////////////////



void sendimage() {
  long mil1=System.currentTimeMillis();
  doframe=false;
  iscmd=false;
  myPort.write(105);
  // String imgstr="";
  screenshot.loadPixels();
  for (int im = 0; im<76800; im++) {

    imgbytes[im]=byte(screenshot.pixels[im] & 0xFF);
  }
  myPort.write(imgbytes);
  long mil2 = System.currentTimeMillis()-mil1;
  println(mil2+" milliseconds  j=" + j );
  iscmd=true;
  doframe=true;
}
void screenshot() {
  try {
    screenshot = new PImage(new Robot().createScreenCapture(new Rectangle(1463, 151, 320, 240)));
    screenshot.filter(GRAY);
  } 
  catch (AWTException e) {
  }
}
void serialEvent(Serial myPort) {
  inByte = myPort.read();
  if (iscmd==true) {
    println("iscmd true j="+j);
    switch(inByte) {
      case (1):
      iscmd=false;  

      // sendimage();
      iscmd=true;
      break;
    }
  }
  if ((getP2screen==true)&&(iscmd==false)) {
    j=j+1;
    inBytes[j] = inByte;
   // println("inside getP2screen j=" + j);

    if (j>=76799) {
      //how many times has a button been released

      println("ok got image is...get2pscreen done");
      getlut=false;
      getP2screen=false;
      saveSerialImage();
     
    
    }
  }
  if ((getlut==true)&&(iscmd==false)) {
    j=j+1;
    lutBytes[j] = inByte;


    if (j>=2047) {
      //how many times has a button been released
      iscmd=true;
      println("ok iscmd is true...lut");
      getlut=false;
      j=-1;
    }
  }
}

public void saveSerialImage() {
  String s=" ";
  String ImageFileName=path+"image"+year()+month()+day()+hour()+minute()+second()+".raw";
  //raw=createWriter(ImageFileName);
  int spixel=0;
  int fpixel=0;
  println("got to saveserialimage");
  for (int ixx=0; ixx<76799; ixx++) {
    spixel=inBytes[ixx];
    //  s=s+ixx+" "+spixel+" i";
  //  spixel=128;

    // raw.print(spixel);
    // raw.print(" ");
    // spixel=128;
    fpixel=(spixel<<16)+(spixel<<8)+spixel;
    serialimg.pixels[ixx]=fpixel;
  }
  print(s);
  // raw.flush();
  //raw.close();
  println("exit saveserialimage");
  iscmd=true;
  serialimg.updatePixels();
}

public void controlEvent(ControlEvent theEvent) {
  // println(theEvent.getController().getName());
  n = 0;
}

public void Export_Region_ply() {
  export_region=true;
  Export_ply();
}
public void Export_ply() {
  if (startup==true) {
    doframe=false;
    goodpoints=-1;
    int iystart=0;
    int iyend=424;
    int ixstart =0;
    int ixend=512;
    int gz=0;
    yloc=0;

    if (export_region == true) {
      //  yloc=recty*512;
      yloc=92*512;
      //'iystart = recty;
      iystart=92;
      //' iyend =recty+rectheight;
      iyend=92+240;
      //' ixstart=rectx;
      ixstart=96;
      // ' ixend = rectx + rectwidth;
      ixend=96+320;
    }
    for (int iy=iystart; iy<iyend; iy++) {

      for (int ix =ixstart; ix< ixend; ix++) {
        cxloc =511-ix;

        gz = rawDataMirror[ix+yloc][0];
        if (gz>0) {
          goodpoints++;
        }
      }
      yloc=yloc+512;
    }
    String plyFileName=path+""+year()+month()+day()+hour()+minute()+second()+".ply";
    String rawFileName=path+""+year()+month()+day()+hour()+minute()+second()+"RAW"+".txt";
    ply=createWriter(plyFileName);
    raw=createWriter(rawFileName);

    println("exporting .ply");
    ply.println("ply");
    ply.println("format ascii 1.0");
    ply.println("comment this is your ply file");
    ply.println("element vertex " + goodpoints);
    ply.println("property float x");
    ply.println("property float y");
    ply.println("property float z");
    ply.println("property uchar red");
    ply.println("property uchar green");
    ply.println("property uchar blue");
    ply.println("end_header");

    yloc=0;
    if (export_region == true) {
      // 'yloc=recty*512;
      yloc=92*512;
    }
    int inc2=0;
    int im=0;
    for (int iy=iystart; iy<iyend; iy++) {

      for (int ix =ixstart; ix< ixend; ix++) {
        cxloc =511-ix;

        pointcolor=  mirror_regImg.pixels[cxloc+yloc];  //color image yloc gets incremented so we don't have the usual multiply here
        gz = rawDataMirror[ix+yloc][0];
        raw.print(inc2+"  "+ix+" " + iy +" "+ pointcolor +" "+ gz+" ");
        floatz =gz;   //raw data from mirror
        if (gz>0) { 

          cxloc=(ix-256);                                  //now raw data
          floatx = ((floatz*(cxloc/ccc)))/1000;
          cyloc=212-iy;
          floaty = ((floatz*(cyloc/ccc2)))/1000;
          floatz=-floatz/1000;

          int pRed =( pointcolor>>16) & 0xFF;
          int pGreen = (pointcolor>>8)&0xFF;
          int pBlue = (pointcolor)& 0xFF;
          pointString=floatx + " "+ floaty +" "+ floatz+" "+ pRed +" "+pGreen + " "+pBlue;


          ply.println(pointString);
        }

        raw.println("");
        inc2++;
      }
      yloc = yloc+512;
    }
    println(pointString);

    raw.flush();
    ply.flush();
    ply.close();
    raw.close();
    iscmd=false;
    sendKinectimage();
    iscmd=true;
    println("done");


    seq++;
    export_region=false;
  }
}
public void KinectV2(int theValue) {

  if ((kinectstart==true)&&(firsttime==true)) {
    firsttime=false;
    kinect.initDevice();
  }

  kinectstart=!kinectstart;
}
public void EXIT(int theValue) {
  println("a button event from ClosePort: "+theValue);
  if (doexit==true) {
    doframe=false;
    exit();
    System.exit(0);
  }
  doexit=true;
}
public void send512() {
  for (int i = 102912; i >102399; i--) {

    int temp1 =temparray[i];
    myPort.write(byte((temp1>>8) & 0xFF));

    myPort.write(byte(temparray[i]& 0xFF));
  }
}
void keyPressed() {
  whichKey = key;
  if (key==50) {
    lookline++;
  }
  if (key==56) {
    lookline--;
  }
}
void keyReleased() {
  // Send the keystroke out:

  if (key==10) {

    doframe=!doframe;
    if (doframe==true) {
    }
  }
  if (portOpen==true) {

    switch(key) {
      case (43):
      myPort.write(43);
      break;
      case (45):
      myPort.write(45);
      break;
      case (48):
      myPort.write(48);
      break;
      case (49):
      myPort.write(49);
      break;
      case (50):
      myPort.write(50);
      break;
      case (51):
      myPort.write(51);
      break;
      case (99):  //copy cog to ram

      i=511;
      j=-1;
      myPort.write(key);

      break;

      case (97):
      myPort.write(key);
      break;
      case (98):
      myPort.write(key);
      break;
      case (100):
      myPort.write(key);
      sendDepthMap();
      break;

      case (101):
      iscmd=true;
      myPort.write(key); 
      break;


      case (104):  //hub to lut

      i=511;
      j=-1;
      myPort.write(key);
      String r = JOptionPane.showInputDialog(null, "Enter start address?", "Decide", JOptionPane.QUESTION_MESSAGE);
      try {
        hubaddress = Integer.parseInt(r);
      } 
      catch(NumberFormatException e) {
        println("you did not enter a number!");
        break;
      }
      byte tempbyte=byte(hubaddress >> 24 & 0xff) ;
      myPort.write(tempbyte);
      tempbyte=byte(hubaddress >> 16 & 0xff) ;
      myPort.write(tempbyte);
      tempbyte=byte(hubaddress >> 8 & 0xff) ;
      myPort.write(tempbyte);
      tempbyte=byte(hubaddress & 0xff) ;
      myPort.write(tempbyte);
      break;

      case (105):   //transfer camera image to serial out
      iscmd=false;
      sendimage();

      iscmd=true;
      break;

      case (107):   //"k"transfer kinect gray image and depth data to serial out
      // myPort.write(107);
      iscmd=false;
      sendKinectimage();
      iscmd=true;
      break; 
      case(110):   // get lut full of ina  "n"
      myPort.write(110);
      break;

      case(111):
      iscmd=false;
      getlut=false;
      getP2screen=false;
      myPort.write(111);               //"o"  tell p2 call Get_OP
      delay(850);
      //tell P2 to send lut to P2E
      whichKey=114;
      iscmd=false;
      i=511;
      j=-1;
      whichbyte=-1;
      getlut=true;
      myPort.write(whichKey);
      break;

      case(112):                  //"p"  tells P2 to send copy of current screen buffer
      j=-1;
      iscmd=false;
      getP2screen=true;
      myPort.write(key);  

      break;


      case(114):  //ge2 lut from serial
      iscmd=false;
      i=511;
      j=-1;
      whichbyte=-1;
      getlut=true;
      myPort.write(key);

      break;


      case(115):
      obj2serial();
      break;
      case (116):
      myPort.write(116);
      break;
    }
  }
}
public void obj2serial() {
  // Open a file and read its binary data 
  String path = "C:/Users/Public/p2/all_cogs_blinkexp.obj";
  byte obj[] = loadBytes(path); 
  myPort.write(115);
  myPort.write(9);   //which cog
  int objbytes = obj.length;
  byte tempbyte=byte(objbytes >> 16 & 0xff) ;
  myPort.write(tempbyte);
  tempbyte=byte(objbytes >> 8 & 0xff) ;
  myPort.write(tempbyte);
  tempbyte=byte(objbytes & 0xff) ;
  myPort.write(tempbyte);
  // Print each value, from 0 to 255 
  for (int kya = 0; kya < obj.length; kya++) { 

    // bytes are from -128 to 127, this converts to 0 to 255 
    myPort.write( obj[kya]); 
    print(obj[kya]);
  } 
  // Print a blank line at the end 
  println(); 
  println(obj.length);
}
public void rawtoimage() {
  //rawData = kinect.getRawDepthData();
  byte blue;
  byte green;
  byte red;
  int tempraw;
  for (int i = 0; i < rawimg.pixels.length; i++) {
    tempraw=rawDataMirror[i][whichsample];
    red =byte(128);
    green = byte(128);
    blue = byte(128);
    if  (rawDataMirror[i][whichsample]<1000) {
      red = byte(255-(rawDataMirror[i][whichsample]/4));
      green = red;
      blue = red;
    } else if (rawDataMirror[i][whichsample]<1500) {
      tempraw = rawDataMirror[i][whichsample]-1000;
      red = byte((tempraw/2));
      green = red;
      blue=0;
    } else if  (rawDataMirror[i][whichsample]<2000) {
      tempraw=rawDataMirror[i][whichsample]-1500;
      red=0;
      blue=byte(tempraw/2);
      green =byte((tempraw/2));
    } else if  (rawDataMirror[i][whichsample]<2500) {
      tempraw=rawDataMirror[i][whichsample]-2000;
      red=byte(tempraw/2);
      ;
      green=0;
      blue =byte(255-tempraw/2);
    } else if  (rawDataMirror[i][whichsample]<4000) {
      tempraw=rawDataMirror[i][whichsample]-2500;
      red=byte(255);//byte(255-tempraw/4);
      green=byte(50+(tempraw/4));
      blue =byte(128); //byte(tempraw/4);
    } else if  (rawDataMirror[i][whichsample]>4000) {
      tempraw=rawDataMirror[i][whichsample]-4000;
      red=byte(255); //byte(tempraw/20);
      green=byte(255);
      blue =byte(tempraw/4);
    }

    rawimg.pixels[i] = color(red, green, blue);
  }
}
void mousePressed() {
  startx = mouseX;
  starty = mouseY;
  endx =startx;
  endy= starty;
  //println("startx  " + mouseX + "  starty   "+mouseY);
  ismeasurement=false;
}

void mouseReleased() {
  endx = mouseX;
  endy = mouseY;
  // println("endx  " + mouseX + "  endy   "+mouseY);
}

void mouseDragged() 
{ 

  if ((startx<rawimagewidth) && (starty<rawimageheight)) {
    line(startx, starty, mouseX, mouseY);
    ismeasurement=true;
  }
}

void mouseWheel(MouseEvent event) {
  float e = event.getCount();
  wheelpos=wheelpos+e;
  //println("position"+wheelpos);
}